open import lib.Prelude 
open List using (_++_) 
open List.In using (_-_ ; skip)
open List.Subset using (_⊆_)
-- open List.InLists
-- open List.Subsets

open import foc.focbind.univ.examples.DefinedAtoms 
open import foc.focbind.univ.Types 
open import foc.focbind.univ.Semantics 
open import foc.focbind.univ.Map

module foc.focbind.univ.ExchangeT where

module Exchange(S : SignatureInterface.Signature) where
  open Semantics(S)
  open SignatureInterface.Signature S
  open Map S

  Both⊆ : Vars -> Vars -> Set
  Both⊆ Ψ Ψ' = Ψ ⊆ Ψ' × Ψ' ⊆ Ψ

  flip : ∀ {Ψ Ψ'} -> Both⊆ Ψ Ψ' -> Both⊆ Ψ' Ψ
  flip (x , y) = (\{_} i -> y i ) , \{_} i -> x i   

  extend : ∀ {Ψ Ψ'} -> (Ψ0 : _) -> Both⊆ Ψ Ψ' -> Both⊆ (Ψ0 ++ Ψ) (Ψ0 ++ Ψ')
  extend Ψ0 (x , y) = (\{_} -> (List.Subset.⊆append-cong{_}{Ψ0}{_} List.Subset.⊆refl x)) , 
                      (\{_} -> (List.Subset.⊆append-cong{_}{Ψ0}{_} List.Subset.⊆refl y))   

  Co : Types.Type -> Types.Vars -> Types.Vars -> Set
  Co _ Ψ Ψ' = Both⊆ Ψ Ψ'
  
  compat : AllCompat Co Co
  compat Types.1⁺ Ψ Ψ' i = _ 
  compat (Types._⊗_ y y') Ψ Ψ' i = i  , i   
  compat Types.0⁺ Ψ Ψ' i = _ 
  compat (Types._⊕_ y y') Ψ Ψ' i = i , i 
  compat (Types.list_ y) Ψ Ψ' i = i 
  compat (Types.D⁺ y) Ψ Ψ' i =  (\{A} c -> i ) , \ {ch} ind -> ▹ ((fst i) ind)
  compat (Types._# y) Ψ Ψ' i = fst i 
  compat (Types._⇒*_ y y') Ψ Ψ' i = extend y i 
  compat (Types.□ y) Ψ Ψ' i = _
  compat (Types.∃c y) Ψ Ψ' i = \ _ -> i 
  compat (Types._⊃_ y y') Ψ Ψ' i = flip i  , i  
  compat (Types.∀c y) Ψ Ψ' i = \ _ -> i 
  compat (Types.∀≤ D A) Ψ Ψ' i = \ Ψ0 _ -> extend Ψ0 i 
  compat (Types.∀⇒_ y) Ψ Ψ' i = \ Ψ0 -> extend Ψ0 i 
  compat (Types.∃⇒_ y) Ψ Ψ' i = \ Ψ0 -> extend Ψ0 i 
  compat (Types.[_]*_ _ _) Ψ Ψ' i = _

  module M = MapSelfDual Co compat
  exchange/anywhere = M.map

  exchange2 : (A : Type) -> {D1 D2 : VarType} -> (∀⇛  (D2 ⇒ D1 ⇒ A)  ⊃  (D1 ⇒ D2 ⇒ A))
  exchange2 A {D1} {D2} Ψ e = exchange/anywhere A ((\{_} -> bi{D1}{D2}) , (\{_} -> bi{D2}{D1}) ) e where 
    bi : ∀ {D1 D2 D} -> D ∈ (D1 :: D2 :: Ψ) -> D ∈ (D2 :: D1 :: Ψ)
    bi i0 = iS i0
    bi (iS i0) = i0
    bi (iS (iS i)) = iS (iS i)

  -- which does it keep?
  contract2 : (A : _) {D : _} -> (∀⇛  (D ⇒ D ⇒ A)  ⊃  (D ⇒ A))
  contract2 A {D} Ψ e = exchange/anywhere A ((\{_} -> bi1) , (\{_} -> bi2)) e where 
    bi1 : ∀ {D1} -> D1 ∈ (D :: D :: Ψ) -> D1 ∈ (D :: Ψ)
    bi1 i0 = i0
    bi1 (iS i0) = i0
    bi1 (iS (iS i)) = iS i

    bi2 : ∀ {D1} -> D1 ∈ (D :: Ψ) -> D1 ∈ (D :: D :: Ψ)
    bi2 i0 = iS i0
    bi2 (iS i) = iS (iS i)

{-
module TestStructural where
--  open Semantics (\_ -> Void)

  testprem : DefAtom -> List Type
  testprem "a" = (D⁺ "b" :: D⁺ "c" :: [])
  testprem "b" = (D⁺ "a" :: D⁺ "c" :: [])
  testprem "c" = (D⁺ "a" :: D⁺ "b" :: [])
  testprem _ = []
-}
