open import lib.Prelude 
open List using (_++_) 
open List.In using (_-_ ; skip)
-- open List.InLists
-- open List.Subsets

open import foc.focbind.univ.examples.DefinedAtoms 
open import foc.focbind.univ.Types 
open import foc.focbind.univ.Semantics 
open import foc.focbind.univ.StrengthenT
open import foc.focbind.univ.WeakenT
open import foc.focbind.univ.ExchangeT
open import foc.focbind.univ.Subst

module foc.focbind.univ.Structural where

module Structural(S : SignatureInterface.Signature) where

  open Semantics(S)
  open Strengthen(S) public using (canStrengthen ; strengthen/anywhere ; strengthen ; canWeaken/irrel ; weaken/irrel/anywhere ; weaken/irrel) 
  open Weaken(S) public using (canWeaken ; weaken* ; weaken ; weaken/anywhere ; weaken*/bounded) 
  open Exchange(S) public using (Both⊆ ; exchange/anywhere ; exchange2 ; contract2)
  open Subst(S) public using (canSubst ; subst/anywhere ; subst)

  extend : ∀ {A D} -> (∀⇛ (D # ⊃ A) ⊃ A ⊃ (D ⇒ D #) ⊃ A)
  extend Ψ σ new i0 = new
  extend Ψ σ new (iS i) = σ i
  
  extendv2v : {D1 D2 : VarType} -> (Ψs : Vars) -> ∀⇛ (var2var D1 Ψs D2)  ⊃  D2 ⇒ (var2var D1 (D1 :: Ψs) D2)
  extendv2v Ψs Ψe w (i0)   = i0
  extendv2v Ψs Ψe w (iS i) = iS (w i)

  skipw   : ∀ {A D1 D2} {_ : Check (Sums.not (eqVarType D1 D2))} {_ : Check (canWeaken (un▹ D2) A)} -> (∀⇛ (D1 # ⊃ A)  ⊃  D2 ⇒ (D1 # ⊃ A))
  skipw {A}{D1}{.D1} {ch} {ch2} Ψ f (i0) = Sums.abort (check-noncontra (eqVarType D1 D1) (eqVarType-refl D1) ch)  
  skipw {A}{D1}{D2} {ch} {ch2} Ψ f (iS i) = (weaken A {_} {ch2} Ψ (f i))

  extendw : ∀ {A D} -> {_ : Check (canWeaken (un▹ D) A)} -> (∀⇛  (D # ⊃ A)  ⊃  A  ⊃  D ⇒ (D # ⊃ A))
  extendw {A}{D} {ch} Ψ f new (i0) = (weaken A {_} {ch} Ψ new)
  extendw {A}{D} {ch} Ψ f new (iS i) = (weaken A {_} {ch} Ψ (f i))

    {-
      contra-only : ∀ {D2 D1} { _ : Check (Sums.not (String.equal D2 D1))} -> <_>_ [] (∀⇒ ((only D1) ⊃ D2 # ⊃ 0⁺))
      contra-only {.D2} {D1} {ch} (D2 :: Ψ) on i0 with (String.equal D2 D1) | check/i (String.equal D2 D1)
      ... | .True  | Inl OK = ch
      ... | .False | Inr Refl = on 
      contra-only {D2} {D1} {ch} (Df :: Ψ) on (iS i) = contra-only{D2}{D1}{ch} Ψ (snd (check-andE{String.equal Df D1} on ) ) i
      contra-only [] on ()
    
      contra-no : ∀ {D} -> <_>_ [] (∀⇒ ((no D) ⊃ D # ⊃ 0⁺))
      contra-no (D :: Ψ) c i0 with String.equal D D | String.same-eq {D} 
      ...                         | .True | Refl = c 
      contra-no {D} (D1 :: Ψ) c (iS i) = contra-no Ψ (snd (check-andE{Sums.not (String.equal D1 D)} c)) i 
      contra-no [] c ()
    -}

  impossible : ∀ {D ch Ψ} {C : Set} {_ : Check (Sums.not (DefinedAtoms.world D))} -> < Ψ > ((▹ D {ch}) #) -> C
  impossible {D} {ch} {Ψ} {C} {ch2} _ = Sums.abort (check-noncontra (DefinedAtoms.world D) ch ch2) 
