open import lib.Prelude 
open List using (_++_) 
open List.In using (_-_)
-- open List.InLists
-- open List.Subsets

open import foc.focbind.univ.examples.DefinedAtoms 
open import foc.focbind.univ.Types 
open import foc.focbind.univ.Semantics 
open import foc.focbind.univ.Structural
open import foc.focbind.univ.examples.Sig

module foc.focbind.univ.examples.Comb where
  open Sig
  open Semantics(theSig)
  open Structural(theSig)

  bracket : ∀⇛ ((combC ⇒ comb) ⊃ comb)
  bracket Ψ (▹ i0) = comb/i · _
  bracket Ψ (▹ (iS x))   = comb/app · (comb/k · _ , ▹ x)
  bracket Ψ (comb/i · _) = comb/app · (comb/k · _ , comb/i · _)
  bracket Ψ (comb/s · _) = comb/app · (comb/k · _ , comb/s · _)
  bracket Ψ (comb/k · _) = comb/app · (comb/k · _ , comb/k · _)
  bracket Ψ (comb/app · (a1 , a2)) = 
    comb/app · (comb/app · (comb/s · _ , 
                            bracket Ψ a1) , 
                bracket Ψ a2)

  combw = (expC # ⊃ combC #)

  extend-combenv : ∀⇛ combw ⊃ (expC ⇒ combC ⇒ combw)
  extend-combenv Ψ σ (iS i0)     = i0
  extend-combenv Ψ σ (iS (iS i)) = iS (iS (σ i))

  tr : ∀⇛ (combw ⊃ exp ⊃ comb)
  tr Ψ σ (▹ x)             = ▹ (σ x)
  tr Ψ σ (app · (e1 , e2)) = comb/app · (tr Ψ σ e1 , tr Ψ σ e1)
  tr Ψ σ (lam · e)         = 
    let 
      a : < Ψ ,, expC ,, combC > comb
      a = tr (Ψ ,, expC ,, combC) (extend-combenv Ψ σ) (weaken exp (Ψ ,, expC) e)

      s : < Ψ ,, combC > comb
      s = strengthen/anywhere comb (iS i0) a
    in 
      bracket Ψ s

  module Test where

    e : ⊡ exp
    e = lam · (lam · (▹ (iS i0)))

    r = tr [] (\ ()) e