open import lib.Prelude 
open List using (_++_) 
open List.In using (_-_)
-- open List.InLists
-- open List.Subsets

module foc.focbind.univ.examples.DefinedAtoms where

-- FIXME: 
-- BUG?: abstracting over this and then implementing this later
-- causes a reduction for 'world' not to fire, which stops some code
-- from type checking

module DefinedAtoms where
  data Atom : Set where
    natA  : Atom
    expA  : Atom
    closA : Atom
    tpA   : Atom
    tmA   : Atom
    ftpA   : Atom
    semA  : Atom
    neuA  : Atom
    sem2A : Atom
    neu2A : Atom
    sem3A : Atom
    neu3A : Atom
    arithA : Atom
    combA  : Atom

  world : Atom -> Bool
  world expA = True
  world tmA = True
  world neuA = True
  world neu2A = True
  world neu3A = True
  world arithA = True
  world combA = True
  world ftpA = True
  world _ = False

  eq : Atom -> Atom -> Bool
  eq natA natA = True
  eq expA expA = True  
  eq closA closA = True
  eq tpA tpA = True
  eq tmA tmA = True
  eq semA semA = True
  eq neuA neuA = True
  eq sem2A sem2A = True
  eq neu2A neu2A = True
  eq sem3A sem3A = True
  eq neu3A neu3A = True
  eq arithA arithA = True
  eq combA combA = True
  eq ftpA ftpA = True
  eq _ _ = False

  -- strings really should have certify-eq and eq-refl...

  eq-refl : (D : Atom) -> Check (eq D D)
  eq-refl natA = _ 
  eq-refl expA = _ 
  eq-refl closA = _ 
  eq-refl tpA = _ 
  eq-refl tmA = _ 
  eq-refl semA = _ 
  eq-refl neuA = _ 
  eq-refl sem2A = _ 
  eq-refl neu2A = _ 
  eq-refl sem3A = _ 
  eq-refl neu3A = _ 
  eq-refl arithA = _ 
  eq-refl combA = _ 
  eq-refl ftpA = _ 

  postulate 
    certify-eq-off-diag : {D1 D2 : Atom} -> Check (eq D1 D2) -> Id D1 D2

  certify-eq : {D1 D2 : Atom} -> Check (eq D1 D2) -> Id D1 D2
  certify-eq {natA} {natA} c = Refl
  certify-eq {expA} {expA} c = Refl
  certify-eq {closA} {closA} c = Refl
  certify-eq {tpA} {tpA} c = Refl
  certify-eq {tmA} {tmA} c = Refl
  certify-eq {semA} {semA} c = Refl
  certify-eq {neuA} {neuA} c = Refl
  certify-eq {sem2A} {sem2A} c = Refl
  certify-eq {neu2A} {neu2A} c = Refl
  certify-eq {sem3A} {sem3A} c = Refl
  certify-eq {neu3A} {neu3A} c = Refl
  certify-eq {arithA} {arithA} c = Refl
  certify-eq {combA} {combA} c = Refl
  certify-eq {ftpA} {ftpA} c = Refl
  certify-eq {_} {_} c = certify-eq-off-diag c
{-
  -- nat
  certify-eq {natA } {expA}  ()
  certify-eq {natA } {closA} ()
  certify-eq {natA } {tpA}   ()
  certify-eq {natA } {tmA}   ()
  certify-eq {natA } {semA}  ()
  certify-eq {natA } {neuA}  ()
  certify-eq {natA } {sem2A} ()
  certify-eq {natA } {neu2A} ()
  -- exp
  certify-eq {expA } {natA}  ()
  certify-eq {expA } {closA} ()
  certify-eq {expA } {tpA}   ()
  certify-eq {expA } {tmA}   ()
  certify-eq {expA } {semA}  ()
  certify-eq {expA } {neuA}  ()
  certify-eq {expA } {sem2A} ()
  certify-eq {expA } {neu2A} ()
  -- clos 
  certify-eq {closA} {natA}  ()
  certify-eq {closA} {expA} ()
  certify-eq {closA} {tpA}   ()
  certify-eq {closA} {tmA}   ()
  certify-eq {closA} {semA}  ()
  certify-eq {closA} {neuA}  ()
  certify-eq {closA} {sem2A} ()
  certify-eq {closA} {neu2A} ()
  -- tp
  certify-eq {tpA} {natA}  ()
  certify-eq {tpA} {expA} ()
  certify-eq {tpA} {closA}   ()
  certify-eq {tpA} {tmA}   ()
  certify-eq {tpA} {semA}  ()
  certify-eq {tpA} {neuA}  ()
  certify-eq {tpA} {sem2A} ()
  certify-eq {tpA} {neu2A} ()
  -- tm
  certify-eq {tmA} {natA}  ()
  certify-eq {tmA} {expA} ()
  certify-eq {tmA} {closA}   ()
  certify-eq {tmA} {tpA}   ()
  certify-eq {tmA} {semA}  ()
  certify-eq {tmA} {neuA}  ()
  certify-eq {tmA} {sem2A} ()
  certify-eq {tmA} {neu2A} ()
  -- sem
  certify-eq {semA} {natA}  ()
  certify-eq {semA} {expA} ()
  certify-eq {semA} {closA}   ()
  certify-eq {semA} {tpA}   ()
  certify-eq {semA} {tmA}  ()
  certify-eq {semA} {neuA}  ()
  certify-eq {semA} {sem2A} ()
  certify-eq {semA} {neu2A} ()
  -- neu
  certify-eq {neuA} {natA}  ()
  certify-eq {neuA} {expA} ()
  certify-eq {neuA} {closA}   ()
  certify-eq {neuA} {tpA}   ()
  certify-eq {neuA} {tmA}  ()
  certify-eq {neuA} {semA}  ()
  certify-eq {neuA} {sem2A} ()
  certify-eq {neuA} {neu2A} ()
  -- sem2
  certify-eq {sem2A} {natA}  ()
  certify-eq {sem2A} {expA} ()
  certify-eq {sem2A} {closA}   ()
  certify-eq {sem2A} {tpA}   ()
  certify-eq {sem2A} {tmA}  ()
  certify-eq {sem2A} {semA}  ()
  certify-eq {sem2A} {neuA} ()
  certify-eq {sem2A} {neu2A} ()
  -- neu         2
  certify-eq {neu2A} {natA}  ()
  certify-eq {neu2A} {expA} ()
  certify-eq {neu2A} {closA}   ()
  certify-eq {neu2A} {tpA}   ()
  certify-eq {neu2A} {tmA}  ()
  certify-eq {neu2A} {semA}  ()
  certify-eq {neu2A} {sem2A} ()
  certify-eq {neu2A} {neuA} ()
-}

