open import lib.Prelude 
open List using (_++_) 
open List.In using (_-_)
-- open List.InLists
-- open List.Subsets

open import foc.focbind.univ.examples.DefinedAtoms 
open import foc.focbind.univ.Types 
open import foc.focbind.univ.Semantics 
open import foc.focbind.univ.Structural
open import foc.focbind.univ.examples.Sig

module foc.focbind.univ.examples.Typecheck where
  open Sig
  open Semantics(theSig)
  open Structural(theSig)

  _&&_ : ⊡ (bool ⊃ bool ⊃ bool)
  (Inl _) && (Inl _) = Inl _
  _ && _ = Inr _

  eqtp : ⊡ (tp ⊃ tp ⊃ bool)
  eqtp (unit · _) (unit · _) = Inl _
  eqtp (arr · (A , B)) (arr · (A' , B')) = (eqtp A A') && (eqtp B B')
  eqtp (prod · (A , B)) (prod · (A' , B')) = (eqtp A A') && (eqtp B B')
  eqtp _ _ = Inr _

  env : Type
  env = tmC #  ⊃  □ tp

  synth : (∀⇛  tm  ⊃  env  ⊃  □ tp ⊕ 1⁺)
  synth Ψ (▹ x) env = Inl (env x)
  synth Ψ (fn · (A , e)) env with synth (tmC :: Ψ) e ( (extend{□ tp}{tmC} Ψ env A) ) 
  ...                           | Inl B = Inl (arr · (A , B ))
  ...                           | Inr _ = Inr _ 
  synth Ψ (ap · (e1 , e2)) env  with synth Ψ e1 env | synth Ψ e2 env
  ...                              | Inl (arr · (A1 , A2)) | Inl B1 
   with eqtp A1 B1
  ... | Inl _ = Inl A2
  ... | Inr _ = Inr _
  synth Ψ (ap · (e1 , e2)) env | _ | _  = Inr _
  synth Ψ (pair · (e1 , e2)) env with synth Ψ e1 env | synth Ψ e2 env
  ...                               | Inl A | Inl B = Inl (prod · (A , B))
  ...                               | _     | _     = Inr _
  synth Ψ (pi1 · e) env with synth Ψ e env
  ...                      | Inl (prod · (A , B)) = Inl A
  ...                      | _ = Inr _
  synth Ψ (pi2 · e) env with synth Ψ e env
  ...                      | Inl (prod · (A , B)) = Inl B
  ...                      | _ = Inr _
  synth Ψ (mt · e) env = Inl (unit · _)

